<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>REGISTER USER</title>
</head>

<body>
    <div class="container-fluid jumbotron bg-light">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h2><span class="text-primary border-bottom"><b>REGISTER USER</b></span></h2>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <button id="btn-new-user" class="btn btn-primary"><i class="fa fa-plus"></i> New User</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <table id="table-user" class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>Firstname</th>
                            <th>Lastname</th>
                            <th>Country</th>
                            <th>Subject</th>
                            <th>Customer Type</th>
                            <th>Register Staus</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
        <!-- Modal Create New User -->
        <div>
            <div id="modal-new-user" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">TẠO USER MỚI</h4>
                            <a role="button" class="close" data-dismiss="modal">&times;</a>
                        </div>
                        <div class="modal-body">
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-firstname" class="form-control" placeholder="Firstname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-lastname" class="form-control" placeholder="Lastname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-country" class="form-control">
                                        <option value="none">Country ...</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="inp-subject" class="form-control" placeholder="Subject ..."></textarea>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-type" class="form-control">
                                        <option value="none">Customer Type ...</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success create-user">Tạo User</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Modal Update User -->
        <div>
            <div id="modal-update-user" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">CHI TIẾT USER</h4>
                            <a role="button" class="close" data-dismiss="modal">&times;</a>
                        </div>
                        <div class="modal-body">
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-firstname" class="form-control" placeholder="Firstname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-lastname" class="form-control" placeholder="Lastname ...">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="none">Country ...</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="inp-update-subject" class="form-control" placeholder="Subject ..."></textarea>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-type" class="form-control">
                                        <option value="none">Customer Type ...</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label class="col-form-label">Register Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-status" class="form-control">
                                        <option value="none">Register Status ...</option>
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success update-user">Update User</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";

    const gHEADER_ROW = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
    const gID_COL = 0;
    const gFIRSTNAME_COL = 1;
    const gLASTNAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gTYPE_COL = 5;
    const gSTATUS_COL = 6;
    const gACTION_COL = 7;

    var gUserId = 0;

    var gTableUser = $("#table-user").DataTable({
        columns: [
            {data: gHEADER_ROW[gID_COL]},
            {data: gHEADER_ROW[gFIRSTNAME_COL]},
            {data: gHEADER_ROW[gLASTNAME_COL]},
            {data: gHEADER_ROW[gCOUNTRY_COL]},
            {data: gHEADER_ROW[gSUBJECT_COL]},
            {data: gHEADER_ROW[gTYPE_COL]},
            {data: gHEADER_ROW[gSTATUS_COL]},
            {data: gHEADER_ROW[gACTION_COL]},
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: `
                    <button class="btn btn-primary edit-user">Sửa</button>
                    <button class="btn btn-danger delete-user">Xóa</button>
                `
            }
        ]
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện load trang
    $(document).ready(onPageLoading);

    // gán sự kiện click button Sửa
    $(document).on("click", ".edit-user", function() {
        onBtnEditClick(this);
    });
    // gán sự kiện click button Update User (trên modal update user)
    $(document).on("click", ".update-user", onBtnUpdateUserClick);

    // gán sự kiện click button Xóa
    $(document).on("click", ".delete-user", function() {
        onBtnDeleteClick(this);
    });

    // gán sự kiện click button New User
    $("#btn-new-user").on("click", onBtnNewUserClick);
    // gán sự kiện click button Tạo User (trên modal new user)
    $(document).on("click", ".create-user", onBtnCreateUserClick);
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // lấy user list và hiển thị vào table
        getUserListAndDisplayDataTable();
    }

    // function xử lý sự kiện click button New User
    function onBtnNewUserClick() {
        // hiện modal New User
        $("#modal-new-user").modal("show");
    }
    // function xử lý sự kiện click button Create User (trên modal New User)
    function onBtnCreateUserClick() {
        console.log("%cBUTTON CREATE USER - CLICK", "color: green");
        // khai báo đối tượng chứa dữ liệu
        let vUserData = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customerType: ""
        };
        // B1: Thu thập dữ liệu
        getNewUserData(vUserData);
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkUserData(vUserData);
        if (vDataValid) {
            // B3: Gọi API tạo user mới
            let vAjaxRequest = apiCreateUser(vUserData);
            vAjaxRequest.done(function(vResponse) {
                // B4: Xử lý hiển thị
                handleCreateUserSuccess();
            })
        }

    }

    // function xử lý sự kiện click button Sửa
    function onBtnEditClick(paramButton) {
        console.log("%cBUTTON SỬA - CLICK", "color: blue");
        // B1: Thu thập dữ liệu
        getUserId(paramButton);
        console.log("User ID: " + gUserId);
        // B3: Gọi API lấy thông tin user bằng ID
        let vAjaxRequest = apiGetUserDetailById();
        vAjaxRequest.done(function(vResponse) {
            // B4: Xử lý hiển thị
            console.log(vResponse);
            $("#modal-update-user").modal("show");
            displayUserDetail(vResponse);
        })
    }
    // function xử lý sự kiện click button Update User (trên modal Update User)
    function onBtnUpdateUserClick() {
        console.log("%cBUTTON UPDATE USER - CLICK", "color: green");
        // khai báo đối tượng chứa dữ liệu
        let vUserData = {
            firstname: "",
            lastname: "",
            country: "",
            subject: "",
            customerType: "",
            registerStatus: "",
        };
        // B1: Thu thập dữ liệu
        getUpdateUserData(vUserData);
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkUserData(vUserData);
        console.log("Validate result: " + vDataValid);
        if (vDataValid) {
            // B3: Gọi API update user detail
            console.log(vUserData);
            let vAjaxRequest = apiUpdateUserDetail(vUserData);
            // B4: Xử lý hiển thị
            vAjaxRequest.done(handleUpdateUserSuccess)
        }
    }

    // function xử lý sự kiện click button Xóa
    function onBtnDeleteClick(paramButton) {
        console.log("%cBUTTON XÓA - CLICK", "color: red");
        getUserId(paramButton);
        console.log("User ID: " + gUserId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy danh sách user
    function apiGetUserList() {
        return $.ajax({
            url: gBASE_URL,
            type: "GET",
        });
    }

    //function gọi API tạo user mới
    function apiCreateUser(paramUserData) {
        return $.ajax({
            url: gBASE_URL,
            type: "POST",
            data: JSON.stringify(paramUserData),
            contentType: gCONTENT_TYPE,
        });
    }

    // function gọi API lấy thông tin user bằng ID
    function apiGetUserDetailById() {
        return $.ajax({
            url: gBASE_URL + gUserId,
            type: "GET",
        });
    }

    // function gọi API update user detail
    function apiUpdateUserDetail(paramUserDetail) {
        return $.ajax({
            url: gBASE_URL + gUserId,
            type: "PUT",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramUserDetail),
        })
    }

    // function lấy user list và hiển thị vào table
    function getUserListAndDisplayDataTable() {
        let vAjaxRequest = apiGetUserList();
        vAjaxRequest.done(function(vResponse) {
            displayTableUser(vResponse);
        });
    }

    // function hiển thị table user
    function displayTableUser(paramUserList) {
        gTableUser.clear();
        gTableUser.rows.add(paramUserList);
        gTableUser.draw();
    }

    // function thu thập user ID khi click button Sửa/Xóa
    function getUserId(paramButton) {
        let vRowClick = $(paramButton).closest("tr");
        gUserId = gTableUser.row(vRowClick).data().id;
    }

    // function thu thập dữ liệu user trên modal New User
    // function trả về đối tượng paramUserData được tham số hóa
    function getNewUserData(paramUserData) {
        paramUserData.firstname = $("#inp-firstname").val().trim();
        paramUserData.lastname = $("#inp-lastname").val().trim();
        paramUserData.country = $("#select-country").val();
        paramUserData.subject = $("#inp-subject").val().trim();
        paramUserData.customerType = $("#select-type").val();
    }

    // function thu thập dữ liệu user trên modal Update User
    // function trả về đối tượng paramUserData được tham số hóa
    function getUpdateUserData(paramUserData) {
        paramUserData.firstname = $("#inp-update-firstname").val().trim();
        paramUserData.lastname = $("#inp-update-lastname").val().trim();
        paramUserData.country = $("#select-update-country").val();
        paramUserData.subject = $("#inp-update-subject").val().trim();
        paramUserData.customerType = $("#select-update-type").val();
        paramUserData.registerStatus = $("#select-update-status").val();
    }

    // function kiểm tra dữ liệu user trên form
    // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
    function checkUserData(paramUserData) {
        if (paramUserData.firstname === "") {
            alert("Vui lòng nhập firstname");
            return false;
        }
        else if (paramUserData.lastname === "") {
            alert("Vui lòng nhập lastname");
            return false;
        }
        else if (paramUserData.country === "none") {
            alert("Vui lòng chọn country");
            return false;
        }
        else if (paramUserData.subject === "") {
            alert("Vui lòng nhập subject");
            return false;
        }
        else if (paramUserData.customerType === "none") {
            alert("Vui lòng chọn customer type");
            return false;
        }
        else if (paramUserData.registerStatus === "none") {
            alert("Vui lòng chọn register status");
            return false;
        }
        return true;
    }

    // function hiển thị user detail lên form modal update user
    function displayUserDetail(paramUserDetail) {
        $("#inp-update-firstname").val(paramUserDetail.firstname);
        $("#inp-update-lastname").val(paramUserDetail.lastname);
        $("#select-update-country").val(paramUserDetail.country);
        $("#inp-update-subject").val(paramUserDetail.subject);
        $("#select-update-type").val(paramUserDetail.customerType);
        $("#select-update-status").val(paramUserDetail.registerStatus);
    }

    // function xử lý hiển thị tạo user mới thành công
    function handleCreateUserSuccess() {
        // thông báo thành công
        alert("Tạo user mới thành công");
        // xóa trắng thông tin trên modal new user
        resetModalNewUserInputField();
        // tải lại user list table
        getUserListAndDisplayDataTable();
        // ẩn modal
        $("#modal-new-user").modal("hide");
    }

    // function xử lý hiển thị update user thành công
    function handleUpdateUserSuccess() {
        // thông báo thành công
        alert("Update user thành công");
        // tải lại user list table
        getUserListAndDisplayDataTable();
        // ẩn modal
        $("#modal-update-user").modal("hide");
    }

    // function reset input field trên modal new user
    function resetModalNewUserInputField() {
        $("#inp-firstname").val("");
        $("#inp-lastname").val("");
        $("#select-country").val("none");
        $("#inp-subject").val("");
        $("#select-type").val("none");
    }


</script>

</html>